<?php
define('IN_FORUM',   true);
define('BB_SCRIPT', 'blackjack');
define('BB_ROOT', './');
require(BB_ROOT .'common.php');

$user->session_start(array('req_login' => true));

function msg($bets, $text) {
    global $template, $lang;

    $title = ($bets === '') ? $lang['BJ']['BLACKJACK'] : sprintf($lang['BJ']['THE_TITLE'], $bets);

    $template->assign_vars(array(
        'MASSAGES_INFO' => true,
        'PAGE_TITLE' => $title,
        'MASSAGES' => $text,
    ));

    print_page('blackjack.tpl', 'simple'/*, 'no_footer'*/);

    return false;
}
//------ Настройки ------//
$bb_cfg['max_open_games'] = 10000;    //Максимальное количество открытых игр
//------ Настройки ------//

$bets = isset($_POST['bet']) ? $_POST['bet'] : '';
$games = isset($_POST['game']) ? $_POST['game'] : '';
$takegame = isset($_GET["takegame"]) ? $_GET["takegame"] : '';


if (!$cards = CACHE('bb_cache')->get('bj_cards'))
{

    $sql = "SELECT card_id, card_points, card_img FROM " . BB_CARDS;

    $cards = array();
    foreach (DB()->fetch_rowset($sql) as $row){

        $cards[$row['card_id']] = $row;

    }

    $cards['count'] = DB()->num_rows(DB()->sql_query($sql));

    CACHE('bb_cache')->set('bj_cards', $cards, 1200);
}

if ($bets || $games || is_numeric($takegame))
{
    cache_rm_user_sessions ($userdata['user_id']);


    if ($games === 'start' || $takegame)
    {
        $cardid = rand(1, $cards['count']);

        if ($games === 'start')
        {
            $numbets = DB()->num_rows(DB()->sql_query("SELECT bj_id FROM " . BB_BLACKJACK . " WHERE bj_placeholder = '". $userdata['username'] ."' AND bj_plstat = 'waiting'"));

            if($userdata["user_tokens"] <= $_POST['bet'] ){

                msg($_POST['bet'], $lang['BJ']['NOT_TOKENS']);
            }
            if($numbets >= $bb_cfg['max_open_games'])msg($_POST['bet'], sprintf($lang['BJ']['MAX_OPEN_GAMES'], $bb_cfg['max_open_games']));

            DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens - $bets WHERE user_id =". $userdata['user_id']);
            DB()->sql_query("INSERT INTO " . BB_BLACKJACK . " (bj_placeholder, bj_points, bj_plstat, bj_bet, bj_cards, bj_date) values('". $userdata['username'] ."', ". $cards[$cardid]['card_points'] .", 'playing', ". $bets.", ". $cardid.", ". TIMENOW.")");
            $id = DB()->sql_nextid();
        }

        if (is_numeric($takegame))
        {
            $gid = $takegame;
            $sql = "SELECT bj_bet, bj_gamer, bj_placeholder FROM " . BB_BLACKJACK . " WHERE bj_id =". $gid;
            if ($row = DB()->fetch_row($sql))
            {
                if($userdata["user_tokens"] <= $row['bj_bet'])
                    msg($row['bj_bet'], $lang['BJ']['NOT_TOKENS']);

                if($row['bj_gamer'])
                    $template->assign_vars(array('JS_ON' => true,));

                if($row['bj_placeholder'] === $userdata['username'])
                    msg($row['bj_bet'], $lang['BJ']['THE_A_GAMES']);

                DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens - ". $row['bj_bet'] ." WHERE user_id = ".$userdata['user_id']);
                DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_gamer = '". $userdata['username'] ."' WHERE bj_id =". $gid);
                DB()->query("INSERT INTO " . BB_BLACKJACK . " (bj_placeholder, bj_points, bj_plstat, bj_bet, bj_cards, bj_date, bj_gamewithid) VALUES('". $userdata['username'] ."', ". $cards[$cardid]['card_points'] .", 'playing', ". $row['bj_bet'] .", ". $cardid.",  ". TIMENOW.", ". $gid.")");

                $id = DB()->sql_nextid();

            }
            else
            {
                bb_die($lang['BJ']['GAME_NOT_FOUND']);
            }
        }

        $template->assign_vars(array(
            'MASSAGES_START' => true,
            'PAGE_TITLE' => sprintf($lang['BJ']['THE_TITLE'], $bets),
            'IMG_CARDS' => "<img src=styles/images/cards/". $cards[$cardid]['card_img'] ." border=0>",
            'CARD_POINTS' => $cards[$cardid]['card_points'],
            'ID_GAMES' => $id,
        ));
    }
    elseif ($games === 'cont')
    {
        $id = $_POST["id"];
        $playerarr = DB()->sql_fetchrow(DB()->sql_query("SELECT * from " . BB_BLACKJACK . " where bj_id= ". $id));

        if ($playerarr["bj_plstat"] === 'waiting')
            msg($playerarr['bj_bet'], $lang['BJ']['GAME_IS_PLAYED']);

        $showcards = "";
        $usedcards = explode(":", $playerarr["bj_cards"]);
        $arr = array();

        foreach($usedcards as $array_list){
            $arr[] = $array_list;
        }

        foreach($arr as $card_id)
        {
            $showcards .= "<img src=styles/images/cards/".$cards[$card_id]["card_img"]." border=0> ";

        }
        $cardid = rand(1, $cards['count']);

        while (in_array($cardid, $arr)) {

            $cardid = rand(1, $cards['count']);

        }

        $showcards .= "<img src=styles/images/cards/".$cards[$cardid]['card_img']." border=0>";

        $points = $playerarr["bj_points"] + $cards[$cardid]['card_points'];
        $mysqlcards = $playerarr['bj_cards'] .":". $cardid;
        DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_points = bj_points + ". $cards[$cardid]['card_points'] .", bj_cards='" .$mysqlcards ."' WHERE bj_id = ". $id);
        if ($points === 21)
        {
            DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_plstat = 'waiting', bj_date = ". TIMENOW ." WHERE  bj_id = ". $id);

            $check = DB()->sql_fetchrow(DB()->sql_query("SELECT bj_gamewithid FROM " . BB_BLACKJACK . " WHERE bj_id=". $id));
            if ($check['bj_gamewithid'])
            {
                $a = DB()->sql_fetchrow(DB()->sql_query("SELECT ". BB_BLACKJACK ." WHERE bj_id = " . $check['bj_gamewithid']));

                if ($a['bj_points'] != 21)
                {
                    DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ".($a['bj_bet']*2)." WHERE user_id = ". $userdata['user_id']);
                    DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = '". $userdata['username'] ."', bj_gamewithid = ". $points .", bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = ". $check['bj_gamewithid']);

                    $winorlose = sprintf($lang['BJ']['YOU_WON'], $a['bj_points']);
                }
                else
                {
                    DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = 'Ничья', bj_gamewithid = ". $points .", bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = ". $check['bj_gamewithid']);

                    DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". $a['bj_bet'] ." WHERE user_id = ". $userdata['user_id']);
                    DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". $a['bj_bet'] ." WHERE user_id = ". get_user_id($a['bj_placeholder']));

                    $winorlose = sprintf($lang['BJ']['NOBODY_WON'], $a['bj_points']);
                }
                DB()->query("DELETE FROM " . BB_BLACKJACK . " WHERE bj_id = ". $id);

                msg($a['bj_bet'], $winorlose);
            }
            else
                msg($playerarr['bj_bet'], $lang['BJ'][21]);
        }
        elseif ($points > 21)
        {

            DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_plstat = 'waiting', bj_date = ". TIMENOW ." WHERE  bj_id = ". $id);

            $check = DB()->sql_fetchrow(DB()->sql_query("SELECT bj_gamewithid FROM " . BB_BLACKJACK . " WHERE bj_id =". $id));
            if ($check['bj_gamewithid'])
            {
                $a = DB()->sql_fetchrow(DB()->sql_query("SELECT * FROM " . BB_BLACKJACK . " WHERE bj_id =". $check['bj_gamewithid']));


                if (($a['bj_points'] >= $points || $points >= $a['bj_points']) && $a['bj_points'] > 21)
                {
                    $winorlose = sprintf($lang['BJ']['NOBODY_WON'], $a['bj_points']);
                    DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = 'Перебор', bj_gamewithid = $points, bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = ". $check['bj_gamewithid']);
                }
                elseif ($a['bj_points'] < $points && $a['bj_points'] <= 21)
                {
                    $winorlose = sprintf($lang['BJ']['YOU_LOST'], $a['bj_points']);

                    DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". ($a['bj_bet']*2) ." WHERE username = '". $a['bj_placeholder'] ."'");
                    if($a['bj_placeholder']) {
                        DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = '" . $a['bj_placeholder'] . "', bj_gamewithid = $points, bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = " . $check['bj_gamewithid']);
                    }
                }
                DB()->query("DELETE FROM " . BB_BLACKJACK . " WHERE bj_id = ". $id);
                msg($a['bj_bet'], $winorlose);
            }
            else
                msg($playerarr['bj_bet'], sprintf($lang['BJ']['BUST'], $points));
        }
        else
        {

            $template->assign_vars(array(
                'MASSAGES_START' => true,
                'STOP'          =>true,
                'PAGE_TITLE' => sprintf($lang['BJ']['THE_TITLE'], $playerarr['bj_bet']),
                'IMG_CARDS' => $showcards,
                'CARD_POINTS' => $points,
                'ID_GAMES' => $id,
            ));
        }
    }
    elseif ($games === 'stop')
    {
        $id = $_POST["id"];
        $playerarr = DB()->sql_fetchrow(DB()->sql_query("SELECT * FROM " . BB_BLACKJACK . " WHERE bj_id =". $id));

        if ($playerarr['bj_plstat'] === 'waiting' || !$playerarr){
            msg($playerarr['bj_bet'], $lang['BJ']['GAME_IS_PLAYED']);
        }

        DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_plstat = 'waiting', bj_date = ". TIMENOW ."  WHERE  bj_id = ". $id);
        if ($playerarr['bj_gamewithid'])
        {
            $a = DB()->sql_fetchrow(DB()->sql_query("SELECT * FROM " . BB_BLACKJACK . " WHERE bj_id =". $playerarr['bj_gamewithid']));
            if ($a['bj_points'] === $playerarr['bj_points'] && $a['bj_points'] < 22 && $playerarr['bj_points'] < 22)
            {
                $winorlose = $lang['BJ']['DRAW'];

                DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". $a['bj_bet'] ." WHERE user_id = ". $userdata['user_id']);
                DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". $a['bj_bet'] ." WHERE username = '". $userdata['username'] ."'");
                DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = 'Ничья', bj_gamewithid = ". $playerarr['bj_points'] .", bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = ". $playerarr['bj_gamewithid']);
                DB()->query("DELETE FROM " . BB_BLACKJACK . " WHERE bj_id = ". $id);


            }
            elseif ($playerarr['bj_points'] < $a['bj_points'] && $a['bj_points'] > 21 || $playerarr['bj_points'] > $a['bj_points'] && $playerarr['bj_points'] < 22)
            {
                $winorlose = sprintf($lang['BJ']['YOU_WON'], $a['bj_points']);

                DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". ($a['bj_bet']*2) ." WHERE user_id = ". $userdata['user_id']);

                if($a['bj_placeholder']) {
                    DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = '" . $userdata['username'] . "', bj_gamewithid = " . $playerarr['bj_points'] . ", bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = " . $playerarr['bj_gamewithid']);
                }

                DB()->query("DELETE FROM " . BB_BLACKJACK . " WHERE bj_id = ". $id);
            }
            elseif ($playerarr['bj_points'] < $a['bj_points'] && $a['bj_points'] <= 21)
            {
                $winorlose = sprintf($lang['BJ']['YOU_LOST'], $playerarr['bj_points']);

                DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". ($a['bj_bet']*2) ." WHERE username = '" . $a['bj_placeholder'] . "'");
                DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = '". $a['bj_placeholder'] ."', bj_gamewithid = ". $playerarr['bj_points'] .", bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = ". $playerarr['bj_gamewithid']);
                DB()->query("DELETE FROM " . BB_BLACKJACK . " WHERE bj_id = ". $id);
            }
            elseif ($a["bj_points"] > 21 && $playerarr["bj_points"] > 21)
            {
                $winorlose = sprintf($lang['BJ']['NOBODY_WON'], $playerarr['bj_points']);

                DB()->query("UPDATE " . BB_USERS . " SET user_tokens = user_tokens + ". ($a['bj_bet']*2) ." WHERE user_id = 1");
                DB()->query("UPDATE " . BB_BLACKJACK . " SET bj_winner = 'Вика', bj_gamewithid = $points, bj_date = ". TIMENOW .", bj_plstat = 'finished' WHERE  bj_id = ". $check['bj_gamewithid']);
            }

            msg($playerarr['bj_bet'], $winorlose);

        }
        else {

            $template->assign_vars(array(
                'JS_ON' => true,
            ));

        }
    }

    print_page('blackjack.tpl', 'simple');

} else {

    $color = array( 5 => "74AE04", 10 => "9E9E9E", 15 => "0574C9", 20 => "DB48A2", 25 => "D8DB04", 50 => "EFA900", 100 => "DC0000",
        500 => "FFC0CB", 1000 => "B0C4DE", 5000 => "ff0000", 10000 => "000000" );

    $sql = DB()->fetch_rowset("SELECT bj_id, bj_placeholder, bj_gamer, bj_date, bj_winner, bj_bet FROM ". BB_BLACKJACK ." WHERE bj_plstat = 'waiting' ORDER BY `bj_date` DESC");

    foreach($sql as $arr)
    {
        $self = ($arr['bj_placeholder'] === $userdata['username'] || $arr['bj_gamer'] ? "disabled" : "");


        $template->assign_block_vars('waiting', array(
            'WINNER'        => ($arr['bj_gamer'] && !$arr['bj_winner']),
            'PLACEHOLDER'   => $arr['bj_placeholder'],
            'GAMER'         => ($arr['bj_gamer'])? $arr['bj_gamer'] : '--',
            'DATA_GAME'     => bb_date($arr['bj_date']),
            'COLOR_BET'     => $color[$arr['bj_bet']],
            'BETS'          => $arr['bj_bet'],
            'GAME_ID'       => $arr['bj_id'],
            'SELF'          => $self,
        ));
    }

    $sql2 = DB()->fetch_rowset("SELECT bj_placeholder, bj_gamer, bj_points, bj_id, bj_date, bj_winner, bj_bet, bj_gamewithid  FROM ". BB_BLACKJACK ." WHERE bj_plstat = 'finished' ORDER BY `bj_date` DESC LIMIT 50");

    foreach($sql2 as $arr){

        $bgcolor = ($userdata['username'] === $arr['bj_gamer'] || $userdata['username'] === $arr['bj_placeholder'] ? 'style="background: #E8DDDD;"' : '');
        $self = ($arr['bj_placeholder'] === $userdata['username'] || $arr['bj_gamer'] ? "disabled" : "");

        if ($arr['bj_gamer'] && !$arr['bj_winner'])
            $winner = " -> <b>???????</b>";
        if ($arr['bj_winner']) {
            $winner = " -> <b>$arr[bj_winner]</b>";
            $pts = $arr['bj_points']." | ".$arr['bj_gamewithid'];
        }

        $template->assign_block_vars('finished', array(
            'WINNER'            => $winner,
            'PLACEHOLDER'       => $arr['bj_placeholder'],
            'GAMER'             => ($arr['bj_gamer'])? $arr['bj_gamer'] : '--',
            'DATA_GAME'         => bb_date($arr['bj_date']),
            'COLOR_BET'         => $color[$arr['bj_bet']],
            'BETS'              => $arr['bj_bet'],
            'GAME_ID'           => $arr['bj_id'],
            'SELF'              => $self,
            'GAME_WIN'          => $pts,
            'BGCOLOR'           => $bgcolor,
        ));
    }

    foreach($color as $val => $color){

        $template->assign_block_vars('bet',array(
            'BET_COLOR'         => $color,
            'BET_GAMES'         => $val,
        ));

    }

    $template->assign_vars(array(
        'GAMES_VIEW'            => true,
        'PAGE_TITLE'            => "Блек Джек",
        'NO_GAMES'              => ((!$sql && !$sql2)? false : true),
    ));

    print_page('blackjack.tpl');
}